二分查找法详解(6种变形)

前言

在之前的博客中,我给大家介绍了最基础的二分查找法(没学的话点我点我!)

今天我将带大家学习二分法的六种变形如何使用,小伙伴们,快来开始今天的学习吧!

文章目录

  • [1,查找第一个(从左到右)= 目标值的,若不存在返回 -1](#1,查找第一个(从左到右)= 目标值的,若不存在返回 -1)
  • [2,查找第一个 >= 目标值的](#2,查找第一个 >= 目标值的)
  • [3,查找第一个 > 目标值的](#3,查找第一个 > 目标值的)
  • [4,查找最后一个 = 目标值的 ,若不存在返回- 1](#4,查找最后一个 = 目标值的 ,若不存在返回- 1)
  • [5,查找最后一个 <= 目标值的](#5,查找最后一个 <= 目标值的)
  • [6,查找最后一个 < 目标值的](#6,查找最后一个 < 目标值的)
  • 总结

1,查找第一个(从左到右)= 目标值的,若不存在返回 -1

与原版二分法其实差不多,当一个数组中有重复的目标值时,使用该方法可以找到从左到右第一个等于目标值的下标。

因为我们要找的是第一个等于目标值的下标,那我们不仅仅在arrmid > key时去左边找,在arrmid>= key我们也要去找,因为我们需要要最左边等于目标值的下标。
注意事项

最后我们要判断left是否越界(left 有可能等于数组元素的个数),而且最后arrleft是否等于要找的key。

代码:

c 复制代码
int efcz(int* arr, int key,int left,int right)
{
 int len = right+1;//数组长度(元素个数)
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] >= key)
		{
			right = mid - 1;
		}
		if (arr[mid] < key)
		{
			left = mid + 1;
		}
	}
	if (left < len&&arr[left] != key)//判断一下是否找到元素
		return -1;
	else
		return left;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,5,6 };//创建数组
	int key = 5;//目标值为5
	int left = 0;//设置左右起点
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key,left,right));//进入二分查找函数
	return 0;
}

2,查找第一个 >= 目标值的

这次我们需要查找第一个大于等于目标值的下标,这次我们不需要判断left越界,如果越界就说明没有找到,说明整个数组都比目标值要小。

代码:

c 复制代码
//思路和第一种一样,我就不加注释了,如果不懂可以私信问我
int efcz(int* arr, int key, int left, int right)
{
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] >= key)
		{
			right = mid - 1;
		}
		if (arr[mid] < key)
		{
			left = mid + 1;
		}
	}
		return left;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,6,8 };
	int key = 7;
	int left = 0;
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key, left, right));
	return 0;
}

3,查找第一个 > 目标值的

这次我们需要查找第一个大于目标值的下标,这次我们同样不需要判断left越界,如果越界就说明没有找到,说明整个数组都比目标值要小。

另外我们需要改变一下函数内部的判断条件,当arrmid <= key时,left = mid + 1

因为我们不是要找相等的,是要找大于目标值的。

代码:

c 复制代码
//思路和第一种一样,我就不加注释了,如果不懂可以私信问我
int efcz(int* arr, int key, int left, int right)
{
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] > key)
		{
			right = mid - 1;
		}
		if (arr[mid] <= key)
		{
			left = mid + 1;
		}
	}
	return left;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,6,8 };
	int key = 5;
	int left = 0;
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key, left, right));
	return 0;
}

4,查找最后一个 = 目标值的 ,若不存在返回- 1

因为我们要找的是第一个等于目标值的下标,那我们不仅仅在arrmid < key时去右边找,在arrmid>= key我们也要去找,因为我们需要要最右边边等于目标值的下标。
注意事项

最后我们要判断right是否越界(right 有可能等于-1),而且最后arrright是否等于要找的key。

代码:

c 复制代码
//思路和第一种一样,我就不加注释了,如果不懂可以私信问我
int efcz(int* arr, int key, int left, int right)
{
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] > key)
		{
			right = mid - 1;
		}
		if (arr[mid] <= key)
		{
			left = mid + 1;
		}
	}
	if (right >= 0 && arr[right] == key)//判断是否找到
		return right;
	else
		return -1;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,6,8 };
	int key = 5;
	int left = 0;
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key, left, right));
	return 0;
}

5,查找最后一个 <= 目标值的

这次我们需要查找第一个小于等于目标值的下标,这次我们不需要判断right越界,如果越界就说明没有找到,说明整个数组都比目标值要大。

代码:

c 复制代码
//思路和第一种一样,我就不加注释了,如果不懂可以私信问我
int efcz(int* arr, int key, int left, int right)
{
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] > key)
		{
			right = mid - 1;
		}
		if (arr[mid] <= key)
		{
			left = mid + 1;
		}
	}
		return right;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,6,8 };
	int key = 4;
	int left = 0;
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key, left, right));
	return 0;
}

6,查找最后一个 < 目标值的

这次我们需要查找第一个小于目标值的下标,这次我们同样不需要判断right越界,如果越界就说明没有找到,说明整个数组都比目标值要大。

另外我们也需要改变一下函数内部的判断条件,当arrmid >= key时,right = mid - 1,因为我们不是要找相等的,是要找小于目标值的。

代码:

c 复制代码
//思路和第一种一样,我就不加注释了,如果不懂可以私信问我
int efcz(int* arr, int key, int left, int right)
{
	int mid = (left + right) / 2;
	while (left <= right)
	{
		mid = (left + right) / 2;
		if (arr[mid] >= key)
		{
			right = mid - 1;
		}
		if (arr[mid] < key)
		{
			left = mid + 1;
		}
	}
	return right;
}
int main()
{
	int arr[10] = { 1,2,3,5,5,5,5,5,6,8 };
	int key = 5;
	int left = 0;
	int right = sizeof(arr) / sizeof(arr[0]);
	printf("%d", efcz(arr, key, left, right));
	return 0;
}

总结

我认为可以分两组记忆这六种变形,前三组一类,后三组一类,前三组都是返回left,后三组都是返回right,同时我们会发现,第一种和第四种,第二种和第五种,第三种和第六种都十分的相似,所以自己练练就能掌握,而且不容易忘记,本期的分享就到这里,如果觉得博主讲的不错的话,千万不要忘记给博主一个关注,点赞,收藏哦~,小伙伴们,我们下期再见!

相关推荐
D e re k ZH5 分钟前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶1 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊1 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发3 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔4 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
Hhy_11075 小时前
《C++深度解构06》手撕 string —— 从底层内存管理到深浅拷贝彻底吃透
c语言·开发语言·c++·学习·visual studio
青少儿编程课堂5 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan6 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
曦樂~16 小时前
Cpp面筋
c语言·c++
Dream it possible!19 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划